
/*
 * ===========================================
 * Java Pdf Extraction Decoding Access Library
 * ===========================================
 *
 * Project Info:  http://www.idrsolutions.com
 * Help section for developers at http://www.idrsolutions.com/support/
 *
 * (C) Copyright 1997-2017 IDRsolutions and Contributors.
 *
 * This file is part of JPedal/JPDF2HTML5
 *
 
 *
 * ---------------
 * PDFViewer.java
 * ---------------
 */

package org.processmining.common.file;

import java.io.File;

public class PDFViewer {

    /**
     * @param args is of type String[]
     */
    public static void main(final String[] args) {

                 //Create display frame
    	Runtime runtime = Runtime.getRuntime();  
        try{  
            //打开文件  
        	System.out.println("Open the pdf file!");
        	File file = new File("src/org/processmining/common/file/OCBCConformanceChecking.pdf");
        	String absolutePath = file.getAbsolutePath();
        	System.out.println("absolutePath: " + absolutePath);
        	
            runtime.exec("rundll32 url.dll FileProtocolHandler "+ absolutePath);  
        }catch(Exception ex){  
            System.out.println("Cannot find the pdf file!");
            ex.printStackTrace();  

        }  





    }

}