package org.processmining.common.frame;

import java.awt.Dimension;

import javax.swing.JComboBox;

public class MyComboBox extends JComboBox<String>
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public MyComboBox(){
		super();
		this.setRenderer(new ComboBoxRenderer(this));
		this.setPrototypeDisplayValue("default width");
//		this.setToolTipText(this.getSelectedItem().toString());
		this.setMaximumSize(new Dimension(100,5));

	}
	
	/**
	 * set the width of item as the length of the input string
	 * @param widthOfString
	 */
	public void initialize()
	{
		this.setRenderer(new ComboBoxRenderer(this));
		this.setPrototypeDisplayValue("default");
		this.setToolTipText((String) this.getSelectedItem());
	}
	
	/**
	 * set the width of item as the length of the input string
	 * @param widthOfString
	 */
	public void setItemWidth(String widthOfString)
	{
		this.setPrototypeDisplayValue(widthOfString);
	}
}