package org.processmining.common.structure;

/**
* Build a structure two store two integer values.
* Note that the values could be null.
* Created by Guangming Li on August 8, 2017
*/
public class IntegerPair{
	private Integer firstValue = null;
	private Integer secondValue = null;
	
	public IntegerPair(Integer firstValue, Integer secondValue){
		this.firstValue = firstValue;
		this.secondValue = secondValue;		
	}

	/**
	 * get the first value;
	 * @return
	 */
	public Integer getFirstValue(){
		return firstValue;
	}
	
	/**
	 * get the second value;
	 * @return
	 */
	public Integer getSecondValue(){
		return secondValue;
	}
	
	/**
	 * set the first value;
	 * @param firstValue
	 */
	public void setFirstValue(Integer firstValue){
		this.firstValue = firstValue;
	}
	
	/**
	 * set the second value;
	 * @param firstValue
	 */
	public void setSecondValue(Integer secondValue){
		this.secondValue = secondValue;
	}
}