package org.processmining.common.table;


import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

public class TableCombobox {
  public static void main(String[] argv) throws Exception {
    JTable table = new JTable();
    DefaultTableModel model = (DefaultTableModel) table.getModel();

    model.addColumn("A", new Object[] { "item1","item12" });
    model.addColumn("B", new Object[] { "item2", "item21"});
    model.setValueAt("3", 0, 0);
    model.setValueAt("1", 1, 0);
    
    String[] values = new String[] { "1", "2", "3" };
    TableColumn col = table.getColumnModel().getColumn(0);
    col.setCellEditor(new MyComboBoxEditor(values));
    col.setCellRenderer(new MyComboBoxRenderer(values));
    

    JFrame frame = new JFrame();
	frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
	frame.getContentPane().add(new JScrollPane(table));
	frame.setVisible(true);
  }
}

