package org.processmining.mxgraph.examples.swing;

import java.util.Hashtable;

import javax.swing.JFrame;

import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.mxgraph.view.mxStylesheet;

public class HelloWorld extends JFrame
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2707712944901661771L;

	public HelloWorld()
	{
		super("Hello, World!");

		mxGraph graph = new mxGraph();
		
		Object parent = graph.getDefaultParent();

//		graph.getModel().beginUpdate();
//		try
//		{
			Object v1 = graph.insertVertex(parent, null, "Hello", 20, 20, 80,
					30,mxConstants.STYLE_SHAPE+"="+mxConstants.SHAPE_RHOMBUS);
			Object v2 = graph.insertVertex(parent, null, "World!", 240, 150,
					80, 30);
			mxCell edge = (mxCell) graph.insertEdge(parent, null, "Edge", v1, v2, "edgeStyle=segmentEdgeStyle");
			graph.setCellsSelectable(false);

			graph.removeCells(new Object[]{edge});                			
			
			

	    	
			mxStylesheet stylesheet = graph.getStylesheet();
			Hashtable<String, Object> style = new Hashtable<String, Object>();
			 style = new Hashtable<String, Object>();    	    
			    style.put(mxConstants.STYLE_DASHED, true);    
			    style.put(mxConstants.STYLE_STROKECOLOR , "blue");
			    style.put(mxConstants.STYLE_DASH_PATTERN, mxConstants.AOCRELATION_DASHED_PATTERN);
//			    style.put(mxConstants.STYLE_EDGE, defaultEdgeStyle);
			    stylesheet.putCellStyle(mxConstants.AOCRELATION, style);
			    graph.getModel().setStyle(edge, mxConstants.AOCRELATION);
			    
			    
		    	mxCell aOCEdgeCell = (mxCell) graph.insertEdge(graph.getDefaultParent(), 
		    			null, "Edge", edge.getSource(),edge.getTarget(), mxConstants.AOCRELATION);
		    	
//			edge.set
//		}
//		finally
//		{
//			graph.getModel().endUpdate();
//		}
		
		mxGraphComponent graphComponent = new mxGraphComponent(graph);
		getContentPane().add(graphComponent);
	}

	public static void main(String[] args)
	{
		HelloWorld frame = new HelloWorld();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(400, 320);
		frame.setVisible(true);
	}

}
