package org.processmining.ocbc.conformance.visualization.panels;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.UUID;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.processmining.ocbc.models.editor.panels.GraphPanel;




public class DeviationInformationPanel {

	JPanel textPane;
	Dimension dimPropertyPanel;
	UUID lastSelectedID;
	GraphPanel graphPanel;
	JTextArea text;
		
	public DeviationInformationPanel( Dimension dimPropertyPanel){
		this.text = new JTextArea("Display deviation information");
		this.textPane = new JPanel(new GridLayout(1,1));
		this.textPane.add(text);
		this.dimPropertyPanel = dimPropertyPanel;
		this.lastSelectedID = null;
		//panel.setPreferredSize(dimPropertyPanel);
	}
	
	public void setGraphPanel(GraphPanel graphPanel){
		this.graphPanel = graphPanel;
	}
	
	public JComponent getComponent(){
		return textPane;
	}
	
	public void updateInformation(String information){
		text.setText(information);				
	}	
	
}
