package org.processmining.ocbc.discovery.metrics;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassNode;


public class OCBCUnit {
	//a uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classNodeId
	//b uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classRelationId
	protected String id;
	protected ActivityNode referenceActivityNode;
	protected ActivityNode targetActivityNode;
	protected List<ClassNode> classNodeList = new ArrayList<ClassNode>();	
	protected List<AOCEdge> aOCRelationList = new ArrayList<AOCEdge>();
	protected int typeFlag;//0: oc; 1: rt
	protected ActivityEdge activityRelation;	
	protected String classRelationId;	
	
	public OCBCUnit(){
	}
	
	public void setId(String id){
		this.id = id;
	}
	
	public String getId(){
		return id;
	}
	
	public ActivityNode getReferenceActivity(){
		return referenceActivityNode;
	}
	
	public void setReferenceActivity(ActivityNode referenceActivityNode){
		this.referenceActivityNode = referenceActivityNode;
	}
	
	public ActivityNode getTargetActivity(){
		return targetActivityNode;
	}
	
	public void setTargetActivity(ActivityNode targetActivityNode){
		this.targetActivityNode = targetActivityNode;
	}	
    
	public List<ClassNode> getClassNodeList(){
		return classNodeList;
	}
	
	public List<AOCEdge> getAOCRelationList(){
		return aOCRelationList;
	}
	
	public ActivityEdge getActivityRelation(){
		return activityRelation;
	}	
	
	public void setActivityRelation(ActivityEdge activityRelation){
		this.activityRelation = activityRelation;
	}
	
	public String getClassRelationId(){
		return classRelationId;
	}
	
	public void setClassRelationId(String classRelationId){
		this.classRelationId = classRelationId;
	}
	
	public int getType(){
		return typeFlag;
	}
	
	public void setType(int typeFlag){
		this.typeFlag = typeFlag;
	}
	
    public static void main(String[] args) throws Exception {
    	  
    }

}