package org.processmining.ocbc.discovery.metrics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassNode;


public class OCBCUnitFamily {
	protected String id;
	protected ActivityNode referenceActivityNode;
	protected ActivityNode targetActivityNode;
	protected List<ClassNode> classNodeList = new ArrayList<ClassNode>();
	protected String classRelationId;	
	protected List<AOCEdge> aOCRelationList = new ArrayList<AOCEdge>();
	protected int typeFlag;//0: oc; 1: rt
	protected List<ActivityEdge> activityRelationList = new ArrayList<ActivityEdge>();
	protected Map<String, OCBCUnit> idVSUnit = new HashMap<String, OCBCUnit>();
	
	public OCBCUnitFamily(){
		
	}
	
	public void setId(String id){
		this.id = id;
	}
	
	public String getId(){
		return id;
	}
	
	public ActivityNode getReferenceActivity(){
		return referenceActivityNode;
	}
	
	public void setReferenceActivity(ActivityNode referenceActivityNode){
		this.referenceActivityNode = referenceActivityNode;
	}
	
	public ActivityNode getTargetActivity(){
		return targetActivityNode;
	}
	
	public void setTargetActivity(ActivityNode targetActivityNode){
		this.targetActivityNode = targetActivityNode;
	}	
	
	public Map<String, OCBCUnit> getIdVSUnit(){
		return idVSUnit;
	}
		
	public List<ClassNode> getClassNodeList(){
		return classNodeList;
	}
	
	public List<AOCEdge> getAOCRelationList(){
		return aOCRelationList;
	}
	
	public List<ActivityEdge> getActivityRelationList(){
		return activityRelationList;
	}
	
	public int getType(){
		return typeFlag;
	}
	
	public void setType(int typeFlag){
		this.typeFlag = typeFlag;
	}
	
	public String getClassRelationId(){
		return classRelationId;
	}
	
	public void setClassRelationId(String classRelationId){
		this.classRelationId = classRelationId;
	}
	
    public static void main(String[] args) throws Exception {
    	  
    }

}