
package org.processmining.ocbc.logconversion.configurations;
 
import java.util.HashMap;
import java.util.List;
import java.util.Map;
 

/*
 * write and read map data structure into/from xml file
 */
public class ConfigurationParameters {
    
    //keep the parameters (i.e., maps) and their names
    private Map<String, Object> nameVSObjectParameter = new HashMap<String, Object>();
    
    private Map<String, List<String>> nameVSListParameter = new HashMap<String, List<String>>();
    private Map<String, Map<String, String>> nameVSMapParameter = new HashMap<String,Map<String, String>>();
    private Map<String, Map<String, List<String>>> nameVSMapListParameter = new HashMap<String,Map<String, List<String>>>();
    private Map<String, Map<String, Map<String, String>>> nameVSMapMapParameter = new HashMap<String,Map<String, Map<String, String>>>();
    private Map<String, Map<String, Map<String, List<String>>>> nameVSMapMapListParameter = new HashMap<String,Map<String, Map<String, List<String>>>>();
    private Map<String, Map<String, Map<String, Map<String, String>>>> nameVSMapMapMapParameter = new HashMap<String,Map<String, Map<String, Map<String, String>>>>();
    
    
//    Map<String, String> connectionParameterNameVSValue = new HashMap<String, String>();
//    
//	Map<String, List<String>> tableVSSelectedRowIds = new HashMap<String, List<String>>();
//	Map<String, List<String>> tableVSClassList = new HashMap<String, List<String>>();
//    Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
//    Map<String, List<String>> tableVSFatherTables = new HashMap<String, List<String>>();
//    Map<String, List<String>> tableColumnVSImpactedTableColumns = new HashMap<String, List<String>>();    
//    Map<String, List<String>> tableVSFKColumns = new HashMap<String, List<String>>();
//    Map<String, List<String>> classVSPKs =  new HashMap<String, List<String>>();
//	Map<String, List<String>> classVSFKs = new HashMap<String, List<String>>();
//	
//    Map<String, Map<String, String>> classVSColumnVSName = new HashMap<String, Map<String, String>>();
//    Map<String, Map<String, String>> tableVSChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
//    Map<String, Map<String, String>> tableClassVSColumnVSConstraint = new HashMap<String, Map<String, String>>();
//	Map<String, Map<String, String>> tableVSObjectChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
//	Map<String, Map<String, String>> activityVSReferredClassVSPath = new HashMap<String, Map<String, String>>();
//	
//    Map<String, Map<String, List<String>>> classVSActivityColumnVSAttributeColumns = new HashMap<String, Map<String, List<String>>>();
//	Map<String, Map<String, List<String>>> tableVSObjectChainedFatherTableVSFKs = new HashMap<String, Map<String, List<String>>>();
//	Map<String, Map<String, List<String>>> tableVSEventChainedFatherTableVSFKs = new HashMap<String, Map<String, List<String>>>();
//    Map<String, Map<String, List<String>>> tableVSChildTableVSForeignKeyList = new HashMap<String, Map<String, List<String>>>();
    
    public ConfigurationParameters(Map<String, Object> nameVSObjectParameter){
    	this.nameVSObjectParameter = nameVSObjectParameter;
    }

	protected void putParameterIntoList() {

	}      
    
    public ConfigurationParameters(){  	

    	
//    	parameterMap.put(ConfigurationConstants.connectionParameterNameVSValueMap, connectionParameterNameVSValue);
//    	parameterMap.put(ConfigurationConstants.TABLEVSCLASSLISTMAP, tableVSClassList);
//    	parameterMap.put(ConfigurationConstants.TABLEVSELECTEDROWIDSMAP, tableVSSelectedRowIds);
//    	parameterMap.put(ConfigurationConstants.TABLEVSFATHERTABLESMAP, tableVSFatherTables);
//    	parameterMap.put(ConfigurationConstants.TABLEVSCHILDTABLEVSFKLISTMAP, tableVSChildTableVSForeignKeyList);
//    	parameterMap.put(ConfigurationConstants.TABLECOLUMNVSIMPACTEDTABLECOLUMNSMAP, tableColumnVSImpactedTableColumns);
//    	parameterMap.put(ConfigurationConstants.ACTIVITYVSCLASSESMAP, activityVSClasses);
//    	parameterMap.put(ConfigurationConstants.CLASSVSCOLUMNVSNAMEMAP, classVSColumnVSName);
//    	parameterMap.put(ConfigurationConstants.CLASSVSACTIVITYCOLUMNVSATTRIBUTECOLUMNSMAP, classVSActivityColumnVSAttributeColumns);
//    	parameterMap.put(ConfigurationConstants.TABLEVSEVENTCHAINEDCHILDTABLEVSFKMAP, tableVSChainedChildTableVSFK);
//    	parameterMap.put(ConfigurationConstants.TABLECLASSVSCOLUMNVSCONSTRAINTMAP, tableClassVSColumnVSConstraint);
//    	parameterMap.put(ConfigurationConstants.CLASSVSPKSMAP, classVSPKs);
//    	parameterMap.put(ConfigurationConstants.CLASSVSFKSMAP, classVSFKs);
//    	parameterMap.put(ConfigurationConstants.TABLEVSOBJECTCHAINEDCHILDTABLEVSFKMAP, tableVSObjectChainedChildTableVSFK);
//    	parameterMap.put(ConfigurationConstants.ACTIVITYVSREFERREDCLASSVSPATHMAP, activityVSReferredClassVSPath);
//    	parameterMap.put(ConfigurationConstants.TABLEVSOBJECTCHAINEDFATHERTABLEVSFKSMAP, tableVSObjectChainedFatherTableVSFKs);
//    	parameterMap.put(ConfigurationConstants.TABLEVSEVENTCHAINEDFATHERTABLEVSFKSMAP, tableVSEventChainedFatherTableVSFKs);
    	
    }
    
	public Map<String, Object> getNameVSObjectParameterMap(){
		return nameVSObjectParameter;
	}
	
	public Map<String, List<String>> getNameVSListParameterMap(){
		return nameVSListParameter;
	}

	public Map<String, Map<String, String>> getNameVSMapParameterMap(){
		return nameVSMapParameter;
	}
	
	public Map<String, Map<String, List<String>>> getNameVSMapListParameterMap(){
		return nameVSMapListParameter;
	}
	
	public Map<String, Map<String, Map<String, String>>> getNameVSMapMapParameterMap(){
		return nameVSMapMapParameter;
	}
	
	public Map<String, Map<String, Map<String, List<String>>>> getNameVSMapMapListParameterMap(){
		return nameVSMapMapListParameter;
	}	
	
	public Map<String, Map<String, Map<String, Map<String, String>>>> getNameVSMapMapMapParameterMap(){
		return nameVSMapMapMapParameter;
	}
}