package org.processmining.ocbc.loggeneration.mysql.dolibarr;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.loggeneration.mysql.eventlist.CreateEventList;
import org.processmining.ocbc.loggeneration.mysql.eventlist.TableEvent;

/*
 * create event state (without object model) list
 */
public class GenerateXOCEventStateList{

	ConfigurationParameters configuration = new ConfigurationParameters();
	
	public GenerateXOCEventStateList(ConfigurationParameters configuration){
		this.configuration = configuration;
	}
	
	public List<TableEvent> createEventList() throws Exception{
		List<TableEvent> rankedChangeList = new ArrayList<TableEvent>();
		CreateEventList eventList = new CreateEventList(configuration);
		eventList.createChangeSequence();
        
        rankedChangeList = eventList.rankChangeSequence();
        System.out.println("size of change list: " + rankedChangeList.size());
        for(TableEvent change :  rankedChangeList){
        	System.out.println("\n ****************");
        	 System.out.println("\n change table: " + change.table);
        	 System.out.println("\n change column: " + change.column);
        	 System.out.println("\n change id: " + change.id);
        	 System.out.println("\n change time: " + change.time);
        	 System.out.println("\n activity: " + change.activity);
        }       
        return rankedChangeList;     			    		
	}
}
