package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class DatabasePanel extends JPanel {
    public static void main(String[] args) throws Exception {
    	
//    	DatabasePanel databaseInspector = new DatabasePanel();
//        JFrame frame = new JFrame();
//        frame.add(databaseInspector);
//        frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
//        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//        frame.setVisible(true);
    }
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    private DatabaseConnectionPanel databaseConnectionPanel;
    private DatabaseTablePanel databaseTablePanel;
    private DataImporterInterface fatherPanel;
    
    public DatabasePanel(DataImporterInterface fatherPanel) throws Exception {
    	this.fatherPanel = fatherPanel;
        setLayout(new BorderLayout());

        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        databaseConnectionPanel = new DatabaseConnectionPanel(this);
        databaseTablePanel = new DatabaseTablePanel(this);
        this.add(databaseConnectionPanel);
        this.add(databaseTablePanel);
		this.setBorder(BorderFactory.createTitledBorder("import database table(s)"));  
    }

    public DatabaseConnectionPanel getDatabaseConnectionPanel(){
		return databaseConnectionPanel;
    }
    
    public DatabaseTablePanel getDatabaseTablePanel(){
		return databaseTablePanel;
    }
    
    public DataImporterInterface getTablePanel(){
		return fatherPanel;
    }
}