package org.processmining.ocbc.models;

import java.util.List;



public interface ActivityNode extends Node{
	
	/**
	 * returns the set of related class nodes
	 * 
	 * @return
	 */
	public List<ClassNode> getRelatedClassNodes();
	
	/**
	 * returns the set of related activity nodes
	 * 
	 * @return
	 */
	public List<ActivityNode> getRelatedActivityNodes();
	
//	/**
//	 * returns the set of related class relations
//	 * 
//	 * @return
//	 */
//	public List<AOCEdge> getRelatedAOCEdges();
		
//	/**
//	 * returns the set of related activity relations
//	 * 
//	 * @return
//	 */
//	public List<ActivityEdge> getRelatedActivityEdges();
		
	/**
	 * set the set of related class nodes
	 * 
	 */
	public void setRelatedClassNodes(List<ClassNode> relatedClassNodes);
	
	/**
	 * set the set of related activity nodes
	 * 
	 */
	public void setRelatedActivityNodes(List<ActivityNode> relatedActivityNodes);
	
	/**
	 * set the set of related class relations
	 * 
	 */
	public void  setRelatedAOCEdges(List<AOCEdge> relatedAOCEdges);
	
	/**
	 * set the set of related activity relations
	 * 
	 */
	public void  setRelatedActivityEdges(List<ActivityEdge> relatedActivityEdges);
	
	public Object clone();
	

}