package org.processmining.ocbc.models;

import java.util.List;

public interface ClassNode extends Node{
	/**
	 * returns the set of related class nodes
	 * 
	 * @return
	 */
	public List<ClassNode> getRelatedClassNodes();
	
	/**
	 * returns the set of related activity nodes
	 * 
	 * @return
	 */
	public List<ActivityNode> getRelatedActivityNodes();
	
//	/**
//	 * returns the set of related class relations
//	 * 
//	 * @return
//	 */
//	public List<ClassEdge> getRelatedClassEdges();
//		
//	/**
//	 * returns the set of related AOC relations
//	 * 
//	 * @return
//	 */
//	public List<AOCEdge> getRelatedAOCEdges();
//	
//	/**
//	 * returns the set of related AOC relations
//	 * 
//	 * @return
//	 */
//	public List<CrelOCEdge> getRelatedCrelOCEdges();
	
	/**
	 * set the set of related class nodes
	 * 
	 */
	public void setRelatedClassNodes(List<ClassNode> relatedClassNodes);
	
	/**
	 * set the set of related activity nodes
	 * 
	 */
	public void setRelatedActivityNodes(List<ActivityNode> relatedActivityNodes);
	
	/**
	 * set the set of related class relations
	 * 
	 */
	public void  setRelatedClassEdges(List<ClassEdge> relatedClassEdges);	
	
	/**
	 * set the set of related AOC relations
	 * 
	 */
	public void  setRelatedAOCEdges(List<AOCEdge> relatedAOCEdges);	
	
	/**
	 * set the set of related creloc relations
	 * 
	 */
	public void  setRelatedCrelOCEdges(List<CrelOCEdge> relatedCrelOCEdges);
	
	public Object clone();
}