package org.processmining.ocbc.models.editor.interaction;

import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JSlider;
import javax.swing.JTextField;

import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.GraphPanel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;
import org.processmining.ocbc.models.visualization.cell.AOCEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ClassEdgeCell;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;


public class EditorMouseListenerAlwaysCardinality implements MouseListener{
	OCBCModel model;
	GraphMouseListener graphMouseListener;
	JTextField text;
	GraphPanel graphPanel;
	InformationPanel informationPanel;
	JSlider childIndex;
	
	public EditorMouseListenerAlwaysCardinality(OCBCModel model, GraphMouseListener graphMouseListener, JTextField text, 
			InformationPanel informationPanel, GraphPanel graphPanel, JSlider childIndex){
		this.model = model;
		this.text = text;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.childIndex = childIndex;
		this.informationPanel = informationPanel;
	}


	public void actionPerformed(ActionEvent e) {	
		informationPanel.updateInformation("action lisntener");
		
		
	}
	
	public void mouseClicked(MouseEvent arg0) {
		MyOriginalCell cell= graphMouseListener.getSelectedCell();
		if(cell != null)
		{			
			System.out.print("cell != null ");
			if(cell instanceof ClassEdgeCell || cell instanceof AOCEdgeCell) {
				informationPanel.updateInformation("Please input the `always` constraint for the selected edge. \n"
						+ "The constraint indicates one object should always have the required number of corresponding events. \n"
						+ "`always` means that the constraint should hold always from the moment the object exists. \n"
						+ "Some input examples for the constraint are 1, 1..* and *.");									
			}
			
						
		}		
	}


	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
//		informationPanel.updateInformation("mouseEntered");
	}


	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
//		informationPanel.updateInformation("mouseExited");
	}


	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
//		informationPanel.updateInformation("mousePressed");
	}


	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
}
