package org.processmining.ocbc.models.impl;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.JFrame;

import org.jgraph.JGraph;

public class ReadAndWriteObject {

	public static  void main(String[] args) 
	{
		  	 
			JGraph graph = new JGraph();
			writeObject(graph, "E:\\office.ocbc");
			graph = (JGraph) readObject("E:\\office.ocbc");
			JFrame frame = new JFrame("SerialGraph");
			frame.getContentPane().add(graph);
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			frame.pack();
			frame.setVisible(true);
	}
	
	public static Object readObject(String filename) 
	{
			try {
				ObjectInputStream in = new ObjectInputStream(
						new BufferedInputStream(new FileInputStream(filename)));
				Object object = in.readObject();
				in.close();
				File file = new File(filename);
				file.delete();
				return object;
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
	}
	
	public static  void writeObject(Object object,
		    String filename) 
		{
				try {
					ObjectOutputStream out = new ObjectOutputStream(
							new BufferedOutputStream(new FileOutputStream(filename)));
					out.writeObject(object);
					out.flush();
					out.close();
					File file = new File(filename);
					System.out.println("File size is " + file.length() + " byte(s)");
				} catch (Exception e) {
					e.printStackTrace();
				}
		}
	   
}