package org.processmining.ocbc.models.impl;
 
import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.Point2D;
 
public class drawLine extends Frame {
 
    public drawLine(String title){
        super(title);
    }
 
    public static void main(String[] args) {
        drawLine f = new drawLine("Frame");
        f.setSize(300, 300);
        f.addMouseListener(new Mousess(f));
        f.setVisible(true);
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }
    public void Draw(int x,int y,int w,int q){
    	int size =100;
    	int style = 88;
        getGraphics().drawLine(x, y, w, q);
        Point2D.Double src = new Point2D.Double(x,y);
        Point2D.Double dst = new Point2D.Double(w,q);

        getGraphics().setColor(Color.blue);
//        getGraphics().setStroke();
        
//        g2.setColor(Color.white);
//		g2.setStroke(getStroke(width));
//		System.out.println("set stroke");
//		g2.draw(view.lineShape);
		
		 Polygon poly =  createLineEnd(size, style, src, dst) ;
//		 Graphics.fillPolygon(poly);
		 ((Graphics2D) getGraphics()).draw(poly);
		 
		 
    }
    
	protected Polygon createLineEnd(int size, int style, Point2D src, Point2D dst) {
		if (src == null || dst == null)
			return null;
		int d = (int) Math.max(1, dst.distance(src));
		int ax = (int) -(size * (dst.getX() - src.getX()) / d/2);
		int ay = (int) -(size * (dst.getY() - src.getY()) / d/2);
		
		Polygon poly = new Polygon();
		poly.addPoint((int) dst.getX(), (int) dst.getY());
		poly.addPoint((int) (dst.getX() + ax/2 + ay / 4), (int) (dst.getY()
				+ ay/2 - ax/4));
		
		poly.addPoint((int) (dst.getX() + ax/2 ), (int) (dst.getY()
				+ ay/2));
		
		poly.addPoint((int) (dst.getX() + ax  + ay / 4), (int) (dst.getY()
				+ ay - ax/4));
					
		poly.addPoint((int) (dst.getX() + ax - ay / 4), (int) (dst.getY()
				+ ay + ax / 4));
					
		poly.addPoint((int) (dst.getX() + ax/2 ), (int) (dst.getY()
				+ ay/2));
					
		Point2D last = (Point2D) dst.clone();
			
		poly.addPoint((int) (last.getX() + ax/2 - ay / 4), (int) (last.getY()
				+ ay/2 + ax / 4));
					
		return poly;		  		
	}
}
 
 
class Mousess extends MouseAdapter {
 
    int X;
    int Y;
    drawLine f;
 
    public Mousess(drawLine f){
        this.f = f;
    }
     
    @Override
    public void mousePressed(MouseEvent e) {
        X = e.getX();
        Y = e.getY();
    }
 
    @Override
    public void mouseReleased(MouseEvent e) {
        f.Draw(this.X, this.Y, e.getX(), e.getY());
    }
}