package org.processmining.ocbc.models.impl;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollBar;
/**
 * 
 * 
 * @author lenovo
 * 
 * 1.需要注意一下 XOR
 * -----------------------setXOR-----------------------
 * -----------------------曲线本身函数------------------
 * -----------------------覆盖曲线函数------------------
 * 
 *2.基本所有的Drag都是虚枉的
 *--------------------------一般都是Release（）才是实在的
 */





public class tool extends JFrame implements MouseListener,MouseMotionListener, AdjustmentListener, ItemListener {

	JFrame frame =new JFrame();
	JPanel p1 = new JPanel(); // 按钮组区域
	JPanel p2 = new JPanel(); // 颜色组区域
	JPanel bottom = new JPanel();// 画板组区域
	JPanel top = new JPanel();// 顶部区域
	
	ImageIcon icon1 =new ImageIcon("src\\huaban\\picture\\c1.jpg");
	ImageIcon icon2 =new ImageIcon("src\\huaban\\picture\\c2.jpg");
	ImageIcon icon3 =new ImageIcon("src\\huaban\\picture\\c3.jpg");
	ImageIcon icon4 =new ImageIcon("src\\huaban\\picture\\c4.jpg");
	ImageIcon icon5 =new ImageIcon("src\\huaban\\picture\\c5.jpg");
	ImageIcon icon6 =new ImageIcon("src\\huaban\\picture\\c6.jpg");
	ButtonGroup g = new ButtonGroup(); // 按钮组
	JRadioButton op1 = new JRadioButton(icon1, true); // 单选框
	JRadioButton op2 = new JRadioButton(icon2, false);
	JRadioButton op3 = new JRadioButton(icon3, false);
	JRadioButton op4 = new JRadioButton(icon4, false);
	JRadioButton op5 = new JRadioButton(icon5, false);
	
	JCheckBox op6 = new JCheckBox(icon6); // 复选框
	
	Color c = Color.black; // 设置画笔颜色，也是刚开始的默认颜色
	Color c1=Color.white;   ///设置按钮背景颜色

	int f = 1;

	int sx, sy, x, y; // 坐标记录

	boolean fill = false;
	boolean flag = false;

	JScrollBar r1 = new JScrollBar(JScrollBar.HORIZONTAL, 251, 4, 0, 255); // 横向滚动条，初始值，扩展大小，最小值，最大值
	JScrollBar g1 = new JScrollBar(JScrollBar.HORIZONTAL, 251, 4, 0, 255);
	JScrollBar b1 = new JScrollBar(JScrollBar.HORIZONTAL, 251, 4, 0, 255);

	public tool() {
		Image icon = Toolkit.getDefaultToolkit().getImage("src\\huaban\\picture\\c6.jpg");
	       frame.setIconImage(icon);
		
		getContentPane().setLayout(new BorderLayout()); // 边界布局

		bottom.setBackground(Color.white); // 设置画板背景颜色

		p1.setLayout(new FlowLayout()); // 按钮为流水布局
		p1.setBackground(Color.white);                  //设置背景颜色

	

		p2.setLayout(new GridLayout(1, 3)); // 设置颜色滚动轴布局
		p2.add(r1);
		p2.add(g1);
		p2.add(b1); // 添加滚动轴
		r1.setBackground(Color.red); // 设置滚动轴颜色
		g1.setBackground(Color.green);
		b1.setBackground(Color.blue);
		
		op1.setBackground(c1);  //设置按钮背景颜色
		op2.setBackground(c1);
		op3.setBackground(c1);
		op4.setBackground(c1);
		op5.setBackground(c1);
		op6.setBackground(c1);

		g.add(op1); // 单选按钮组
		g.add(op2);
		g.add(op3);
		g.add(op4);
		g.add(op5); 
		
		

		// 添加按钮进入面板p1
		p1.add(op1);
		p1.add(op2);
		p1.add(op3);
		p1.add(op4);
		p1.add(op5);
		p1.add(op6);

		top.setLayout(new GridLayout(2, 1, 10, 5));
		top.add(p1);
		top.add(p2); // 顶部区域增加组建p1,p2

		op6.addItemListener(this); // 填充按钮增加监听器
		r1.addAdjustmentListener(this); // 红色 监听器
		g1.addAdjustmentListener(this); // 绿色 监听器
		b1.addAdjustmentListener(this); // 蓝色 监听器

		op1.addItemListener(this); // 图形选择 监听器
		op2.addItemListener(this);
		op3.addItemListener(this);
		op4.addItemListener(this);
		op5.addItemListener(this);

		bottom.addMouseListener(this); // 画板设置监听器
		bottom.addMouseMotionListener(this); // 画板设置监听器

		getContentPane().add(top, "North");
		getContentPane().add(bottom, "Center"); // 这样设置可以实现画板随窗口大小变化而延伸

		this.setTitle("画板"); // 标题
		this.setSize(800, 500); // 大小
		this.setVisible(true); // 可见
		this.setLocationRelativeTo(null); // 居中
		this.setDefaultCloseOperation(3); // 随窗口关闭而关闭进程

	}

	/**
	 * mousePressed() 设置图形绘画起点 mouseReleased() 设置鼠标释放时候进行覆盖重画 mouseDragged() 也是画
	 * 画出的图跟用mouseReleased()画出来的 一样，只是更加体现过程。
	 */

	// 注册鼠标事件监听器
	public void mousePressed(MouseEvent e) {
		flag = false;
		sx = e.getX();
		sy = e.getY(); // 获取鼠标按下时的坐标
	}
	public void mouseReleased(MouseEvent e) {
		int x0, y0;
		Graphics g = bottom.getGraphics(); // 获取按钮事件
		switch (f) { // 覆盖 重画
		case 2: // 直线
		
 		   g.drawLine(sx,sy,x,y);
 		   x=e.getX();  y=e.getY();
 		   g.setColor(c);
 	
 		   g.drawLine(sx, sy, x, y);
 		   break;
		case 3:
		case 4:
			x = e.getX();
			y = e.getY();
			x0 = x > sx ? sx : x;
			y0 = y > sy ? sy : y;
			g.setColor(c);
			if (!fill) {
				if (f == 3)
					g.drawOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				else
					g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
			}
			else {
				if (f == 3)
					g.fillOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				else
					g.fillRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
			}
			break;
		case 5:
			g.setColor(Color.white);
			x = e.getX();
			y = e.getY();
			x0 = x > sx ? sx : x;
			y0 = y > sy ? sy : y;
			g.fillRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
			g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
			break;
		}
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}
	public void mouseMoved(MouseEvent e) {
	}
	/**
	 * Dragged()都是最终不实现的，使用XOR 只展现过程曲线
	 * 最终都会小时，真正实现“画出来”的是Release()
	 */
	public void mouseDragged(MouseEvent e) {
		int x0, y0;
		Graphics g = bottom.getGraphics();
		switch (f) {
		case 1: // 画任意线
			
			x = e.getX();
			y = e.getY();
			g.setColor(c);
			
			g.drawLine(sx, sy, x, y);
			sx = x;
			sy = y;
			break;
		case 2:
			g.setColor(c);
			if (!flag) {
				x = e.getX();
				y = e.getY();
				g.drawLine(sx, sy, x, y);
				
				flag = true;
			}
			else {
				// 实现重画 用白色的画笔重画所有的轨迹 也就是抹去拖拽过程中的痕迹
				//设置异或 进入绘图模式
				g.setXORMode(Color.white);
				g.drawLine(sx, sy, x, y);
				// 开始覆盖
				x = e.getX();
				y = e.getY();
				g.drawLine(sx, sy, x, y);
			}
			break;
		case 3:
		case 4:
			
			g.setColor(c);
			if (!flag) {
				x = e.getX();
				y = e.getY();
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;
				
				if (!fill) {
					if (f == 3)
						g.drawOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				}
				else {
					if (f == 3)
						g.fillOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.fillRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				}
				flag = true;
			}
			else {
			
			
				// 声明异或 进入绘图模式
				g.setXORMode(Color.white);
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;
				// 开始画
				if (!fill) {
					if (f == 3)
						g.drawOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				} else {
					if (f == 3)
						g.fillOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.fillRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				}
				// 开始覆盖
				x = e.getX();
				y = e.getY();
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;
				if (!fill) {
					if (f == 3)
						g.drawOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				} else {
					if (f == 3)
						g.fillOval(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
					else
						g.fillRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				}
			}
			break;
			
			
		case 5:
			g.setColor(c);
	
			if (!flag) {
				x = e.getX();
				y = e.getY();
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;	
				g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				flag = true;
			}
			else{
				// 声明异或 进入绘图模式
				g.setXORMode(Color.white);
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;
				//开始绘画
				g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
				// 开始覆盖
				x = e.getX();
				y = e.getY();
				x0 = x > sx ? sx : x;
				y0 = y > sy ? sy : y;
				g.drawRect(x0, y0, Math.abs(x - sx), Math.abs(y - sy));
			}
		
			break;
		
			
		}
	}

	public void adjustmentValueChanged(AdjustmentEvent e) {
		// 滚动条可以产生AdjustmentEvent类代表的调整事件
		// 当用户改变滑块位置时会产生调整事件.
		// Color(R,G,B)这个是一个调试颜色的函数
		// getValue()是获取当前滚动轴的值
		c = new Color(r1.getValue(), g1.getValue(), b1.getValue());
		c1=new Color(r1.getValue(), g1.getValue(), b1.getValue());
		r1.setBackground(new Color(r1.getValue(), 0, 0));
		g1.setBackground(new Color(0, g1.getValue(), 0));
		b1.setBackground(new Color(0, 0, b1.getValue()));
		p1.setBackground(c);
		
		op1.setBackground(c1);  //设置按钮背景颜色
		op2.setBackground(c1);
		op3.setBackground(c1);
		op4.setBackground(c1);
		op5.setBackground(c1);
		op6.setBackground(c1);
	}

	public void itemStateChanged(ItemEvent e) {
		/**
		 * 选择事件事件源 当在单选按钮组中选择时会产生选择事件 当用户单击复选框改变它的选中状态时，会产生选择事件
		 */
		// instanceof 指出对象是否是特定类的一个实例 返回一个布尔值
		if (e.getItemSelectable()/* 获取事件源 */instanceof JCheckBox) {
			JCheckBox temp = (JCheckBox) e.getItemSelectable(); // 强制转换
			fill = temp.isSelected(); // 判断复选框是否被选中
		} else { // 单选框
			JRadioButton temp = (JRadioButton) e.getItemSelectable();
			if (temp == op1)
				f = 1; // 自由画
			else if (temp == op2)
				f = 2; // 直线
			else if (temp == op3)
				f = 3; // 椭圆
			else if (temp == op4)
				f = 4; // 矩形
			else if (temp == op5)
				f = 5; // 橡皮擦
		}
	}

	public static void main(String args[]) {

		tool mainFrame = new tool();

	}
}

