package org.processmining.ocbc.performance.logprojection.calculators;

import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.impl.XAttributeDiscreteImpl;
import org.processmining.ocbc.performance.logprojection.DataManager.AttributeValueCalculator;

public class SequenceNumberAttributeCalculator implements
		AttributeValueCalculator<XEvent> {
	private final String sequenceNumber;

	public SequenceNumberAttributeCalculator(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}

	@Override
	public XAttribute[] computeAttributes(XEvent event,
			int traceIndex, int... header) {

		XAttribute a2 = new XAttributeDiscreteImpl(sequenceNumber,
				header[1]);

		return new XAttribute[] { a2 };

	}
}