package org.processmining.common.dialogue;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class DoNotShowAgainMessageBox extends JPanel {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JCheckBox dontAskMeAgain;
	private JLabel label = new JLabel();
    public DoNotShowAgainMessageBox() {
        setLayout(new BorderLayout());     
        this.add(label);
        dontAskMeAgain = new JCheckBox("Don't show again");
        JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        panel.add(dontAskMeAgain);
        add(panel, BorderLayout.SOUTH);
    }

    public boolean dontAskMeAgain() {
        return dontAskMeAgain.isSelected();
    }

    public void showConfirmDialog(Component parent, String message) {   	
    	label.setText(message);
        if (!dontAskMeAgain()) {
            JOptionPane.showMessageDialog(parent, this);
        }
    }
    
    public static void main(String[] str){
    	DoNotShowAgainMessageBox box = new DoNotShowAgainMessageBox();
    	for(int i=0; i<5; i++){
    		box.showConfirmDialog(null,"hello" + i);
    	}
    }

}