package org.processmining.common.memory;
/**
* Measures the approximate size of an object in memory, given a Class which
* has a no-argument constructor.
*/
import java.lang.instrument.Instrumentation;

public class ObjectSizeFetcher {
    private static Instrumentation instrumentation;

    public static void premain(String args, Instrumentation inst) {
        instrumentation = inst;
    }

    public static long getObjectSize(Object o) {
    	return instrumentation.getObjectSize(o);
    }
}

