package org.processmining.ocbc.discovery.metrics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ClassNode;


public class XOCSegment {
	//a uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classNodeId
	//b uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classRelationId
	protected String id;
	protected String referenceActivityName;
	protected String targetActivityName;	
	protected Map<String, XOCCase> idVSCase = new HashMap<String, XOCCase>();
	
	
	protected List<ClassNode> classNodeList = new ArrayList<ClassNode>();	
	protected List<AOCEdge> aOCRelationList = new ArrayList<AOCEdge>();
	protected int typeFlag;//0: oc; 1: rt
	protected ActivityEdge activityRelation;	
	protected String classRelationId;	
	
	public XOCSegment(){
	}
	
	public void setId(String id){
		this.id = id;
	}
	
	public String getId(){
		return id;
	}
	
	public String getReferenceActivityName(){
		return referenceActivityName;
	}
	
	public void setReferenceActivityName(String referenceActivityName){
		this.referenceActivityName = referenceActivityName;
	}
	
	public String getTargetActivityName(){
		return targetActivityName;
	}
	
	public void setTargetActivityName(String targetActivityName){
		this.targetActivityName = targetActivityName;
	}	
    
	public List<ClassNode> getClassNodeList(){
		return classNodeList;
	}
	
	public List<AOCEdge> getAOCRelationList(){
		return aOCRelationList;
	}
	
	public ActivityEdge getActivityRelation(){
		return activityRelation;
	}	
	
	public void setActivityRelation(ActivityEdge activityRelation){
		this.activityRelation = activityRelation;
	}
	
	public String getClassRelationId(){
		return classRelationId;
	}
	
	public void setClassRelationId(String classRelationId){
		this.classRelationId = classRelationId;
	}
	
	public int getType(){
		return typeFlag;
	}
	
	public void setType(int typeFlag){
		this.typeFlag = typeFlag;
	}

	public Map<String, XOCCase> getIdVSCase(){
		return idVSCase;
	}
	
    public static void main(String[] args) throws Exception {
    	  
    }
}