package org.processmining.ocbc.log.model;

/**
 * This interface is implemented by all elements of an event log structure.
 * It defines that all elements are attributable.
 * 
 * Further, this interface requires all event log elements to be cloneable.
 * 
 * @author Christian W. Guenther (christian@deckfour.org)
 *
 */
public interface XOCElement extends XAttributable, Cloneable {
	
	/**
	 * Creates an identical copy of this element.
	 * 
	 * @return An identical clone.
	 */
//	public Object clone();

}