/**
 * Copyright (c) 2007-2012, JGraph Ltd
 */
package org.processmining.ocbc.log.model.impl;

/**
 * Contains all global constants.
 */
public class xConstants
{
	/**
	 * Name of common attributes-Guangming-2016-Oct-21
	 */		
	public static final String ID  = "id";
	
	/**
	 * Name of hierachy nodes in XOC logs-Guangming-2016-Oct-21
	 */	
	public static final String LOG  = "log";
	
	public static final String FORMAT  = "format";
	
	public static final String TOTAL  = "total";
	
	public static final String 	UPDATE  = "update";
	
	public static final String EVENT  = "event";
	
	public static final String REFERERNCES  = "references";
	
	public static final String MODEL  = "model";
	
	public static final String OBJECTS  = "objects";
	
	public static final String OBJECT  = "object";
	
	public static final String RELATIONS  = "relations";
	

	
	/**
	 * Name of event attributes-Guangming-2016-Oct-21
	 */		
	public static final String ACTIVITY  = "activity";
	
	public static final String TIMESTAMP  = "timestamp";	
	
	
	/**
	 * Name of object attributes-Guangming-2016-Oct-21
	 */	
	public static final String CLASS  = "class";	
		
	/**
	 * Name of XOC object attributes-Guangming-2017-July-26 (and possible values)
	 */	
	public static final String lifecycle  = "lifecycle";	
	
	public static final String add  = "add";
	
	public static final String update  = "update";
	
	public static final String delete  = "delete";
	
	public static final String remain  = "remain";
	
	/**
	 * Name of object relation attributes-Guangming-2016-Oct-21
	 */	
	public static final String RELATION  = "relation";	//indicate the relation type of object relations
	
	public static final String SOURCEOBJECTID = "sourceobjectid";	
	
	public static final String TARGETOBJECTID = "targetobjectid";	
	
	public static final String relationship_type = "relationship_type";	
	
	public static final String source_class = "source_class";	
	
	public static final String target_class = "target_class";	
	
	public static final String source_always_cardinality = "source_always_cardinality";	
	
	public static final String source_eventually_cardinality = "source_eventually_cardinality";
	
	public static final String target_always_cardinality = "target_always_cardinality";
	
	public static final String target_eventually_cardinality = "target_eventually_cardinality";
	

	
	/**
	 * Name of XOC log generator variants, such as "database", "csv", "excel" -Guangming-2016-Oct-24
	 */	
	public static final String DATABASEVARIANT  = "database";	
	
	public static final String CSVVARIANT = "csv";	
	
	public static final String EXCELVARIANT = "excel";
	
	/**
	 * Name of columns in the table structure panel of XOC log generator, such as "attribute(a)", "pk(c)"-Guangming-2016-Oct-26
	 */	
	public static final String INDEX = "index";
	
	public static final String TABLEFIELDNAME = "field(t)";	
	
	public static final String TABLEFIELDTYPE = "type(t)";
	
	public static final String ACTIVITYATTRIBUTE  = "attribute(a)";	//indicate the attribute belongs to the activity
	
	public static final String CLASSACTIVITYFIELD  = "activity(c)";	//indicate the attribute belongs to the activity
	
	public static final String CLASSPK = "pk(c)";	
	
	public static final String CLASSFK = "fk(c)";
	
	public static final String CLASSATTRIBUTENAME = "name(c)";	
	
	public static final String CLASSCONSTRAINT = "constraint(c)";
	
	public static final String FAKEKEY = "fake_key";
	
//	public static final List<String> NECESSARYATTRIBUTELIST = Collections.unmodifiableList(
//		    new ArrayList<String>() {/**
//				 * 
//				 */
//				private static final long serialVersionUID = 1L;
//
//			{
//		        add(TYPE);
//		        add(TABLE);
//		        add(ROWID);
//		        add(ACTIVITY);
//		        add(CARDINALITYTYPE);
//		        add(SOURCEALWAYSCARDINALITY);
//		        add(SOURCEEVENTUALLYCARDINALITY);
//		        add(TARGETALWAYSCARDINALITY);
//		        add(TARGETEVENTUALLYCARDINALITY);
//		    }});

	
	public xConstants(){

//		NECESSARYATTRIBUTELIST.add(TYPE);
		
//		public static final String   = "type";//indicate the type of the cell(such as "Class", "ActivityRelation")
//		
//		public static final String CARDINALITYTYPE  = "CardinalityType";//indicate the cardinality of activity relation
//		
//		public static final String SOURCEALWAYSCARDINALITY  = "SourceAlwaysCardinality";//indicate the source always cardinality of class and aoc relation
//		
//		public static final String SOURCEEVENTUALLYCARDINALITY  = "SourceEventuallyCardinality";//indicate the source Eventually cardinality of class and aoc relation
//		
//		public static final String TARGETALWAYSCARDINALITY  = "TargetAlwaysCardinality";//indicate the Target always cardinality of class and aoc relation
//		
//		public static final String TARGETEVENTUALLYCARDINALITY  = "TargetEventuallyCardinality";//indicate the Target Eventually cardinality of class relation
//		
	}
	
}
