/**
 * Copyright (c) 2007-2012, JGraph Ltd
 */
package org.processmining.ocbc.logconversion.configurations;

/**
 * Contains all global constants.
 */
public class ConfigurationConstants
{
	/**
	 * Name of map configuration for data model
	 */
	
	public static final String 	TABLEVSELECTEDROWIDSMAP = "tableVSSelectedRowIds";
	
	public static final String 	SCHEMA = "schema";
	
	public static final String 	ACTIVITYVSCLASSESMAP = "activityVSClasses";
	
	public static final String 	TABLEVSFATHERTABLESMAP = "tableVSFatherTables";
	
	public static final String  TABLEVSCHILDTABLEVSFKLISTMAP = "tableVSChildTableVSForeignKeyList";
	
	public static final String 	TABLECOLUMNVSIMPACTEDTABLECOLUMNSMAP = "tableColumnVSImpactedTableColumns";
	
	public static final String 	TABLEVSCLASSLISTMAP = "tableVSClassList";
	
	public static final String 	CLASSVSCOLUMNVSNAMEMAP = "classVSColumnVSName";
	

	
	public static final String 	CLASSVSACTIVITYCOLUMNVSATTRIBUTECOLUMNSMAP = "classVSActivityColumnVSAttributeColumns";
		
	public static final String 	TABLEVSEVENTCHAINEDCHILDTABLEVSFKMAP = "tableVSEventChainedChildTableVSFK";
	
	public static final String 	TABLEVSEVENTCHAINEDFATHERTABLEVSFKSMAP = "tableVSEventChainedFatherTableVSFKs";
	
	public static final String 	TABLECLASSVSCOLUMNVSCONSTRAINTMAP = "tableClassVSColumnVSConstraint";
	
	public static final String 	CLASSVSPKSMAP = "classVSPrimaryKeys";
	
	public static final String 	CLASSVSFKSMAP = "classVSForeignKeys";
	
	public static final String 	TABLEVSOBJECTCHAINEDCHILDTABLEVSFKMAP = "tableVSObjectChainedChildTableVSFK";
	
	public static final String 	ACTIVITYVSREFERREDCLASSVSPATHMAP = "activityVSReferredClassVSPath";
	
	public static final String 	TABLEVSOBJECTCHAINEDFATHERTABLEVSFKSMAP = "tableVSObjectChainedFatherTableVSFKs";
	
	public static final String 	classVSActivityColumnVSName = "classVSActivityColumnVSName";
	
	public static final String 	tableVSChildTables = "tableVSChildTables";
	
	public static final String 	tableVSChainedChildTables = "tableVSChainedChildTables";
	
	public static final String 	tableVSEventColumns = "tableVSEventColumns";	
	
	public static final String 	nameVSJtableMap = "nameVSJtableMap";	
	
	/**
	 * Name of map configuration for database connection
	 */
	public static final String 	connectionParameterNameVSValueMap = "connectionParameterNameVSValueMap";//keep the parameter for connection to the database
	
	public static final String 	driver = "driver";//indicate the driver used to connect to the database, such as "jdbc:mysql"
	
	public static final String 	host = "host";//indicate the host, such as "localhost"
	
	public static final String 	port = "port";//indicate the port, such as "3306"
	
	public static final String 	userName = "userName";//indicate the user name, such as "root"
	
	public static final String 	password = "password";//indicate the password, such as 
	
	public static final String 	schema = "schema";//indicate the schema, such as "onlineshopping"
	
	/**
	 * Name of column configuration for table reference
	 */
	public static final String 	index = "index";//indicate the index 
	
	public static final String 	child_table = "child_table";//indicate the child table
	
	public static final String 	fk = "fk";//indicate the foreign key
	
	public static final String 	father_table = "father_table";//indicate the father table
	
	public static final String 	pk = "pk";//indicate the primary key
	
	public static final String 	e_c_chained = "e_down";//indicate the event child chained 
	
	public static final String 	e_f_chained = "e_up";//indicate the event father chained 
	
	public static final String 	o_c_chained = "o_down";//indicate the object child chained 
	
	public static final String 	o_f_chained = "o_up";//indicate the object father chained 	
}
