package org.processmining.ocbc.loggeneration;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;



public class Event {
	public String id;
	public String activity;
	public String resource;
	public Date timestamp;
	public List<String> referredObjectIdList = new ArrayList<String>();
	public List<TableObject> referredObjectList = new ArrayList<TableObject>();
	public List<TableObject> currentObjectList = new ArrayList<TableObject>();
	public List<ObjectRelation> currentObjectRelationList = new ArrayList<ObjectRelation>();
	public Map<String, String> attributes = new HashMap<String, String>(); //hold the attributes for events
}