package org.processmining.ocbc.models.editor.panels;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.UUID;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;



public class InformationPanel {
	JPanel textPane;
	JTabbedPane tabPane;
	Dimension dimPropertyPanel;
	UUID lastSelectedID;
	GraphPanel graphPanel;
	JTextArea text;
		
	public InformationPanel( Dimension dimPropertyPanel){
		this.text = new JTextArea("Display information");
		this.textPane = new JPanel(new GridLayout(1,1));
		this.textPane.add(text);		
		this.text.setLineWrap(true);
		this.text.setWrapStyleWord(true);
		this.tabPane = new JTabbedPane();
		this.dimPropertyPanel = dimPropertyPanel;
		this.lastSelectedID = null;
		//panel.setPreferredSize(dimPropertyPanel);
	}
	
	public void setGraphPanel(GraphPanel graphPanel){
		this.graphPanel = graphPanel;
	}
	
	public JComponent getComponent(){
		return textPane;
	}
	
	public String getText(){
		return text.getText();
	}
	
	public void updateInformation(String information){
		text.setText(information);		
		textPane.repaint();
	}	
	
	
}
