package org.processmining.ocbc.models.impl;

import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.Edge;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;

//public abstract class EdgeImpl implements Edge{
public class EdgeImpl implements Edge{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2470053951107610643L;
	/**
	 * 
	 */

	
	protected String name = null;
	private String ID;
	private MyOriginalCell correspondingCell;
	
	public String getEdgeName() {
		return name;
	}
	
	public void setEdgeName(String name) {
		this.name = name;		
	}

	public String getID() {
		return ID;
	}
	
	public void setID(String ID) {
		this.ID = ID;		
	}
	
	public MyOriginalCell getCorrespondingCell(){
		return correspondingCell;
	}
	
	public void setCorrespondingCell(MyOriginalCell correspondingCell){
		this.correspondingCell = correspondingCell;
	}
	
	
//	public Object clone() {		
//		EdgeImpl clone = new EdgeImpl();
////		try {
////			clone = (EdgeImpl) super.clone();
////		} catch (CloneNotSupportedException e) {
////			e.printStackTrace();
////			return null;
////		}
//		clone.ID = ID;
//		clone.name = name;
////		if(correspondingCell != null){
////			clone.correspondingCell = (MyOriginalCell) correspondingCell.clone();
////		}
//		return clone;
//	}
	
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
	
	public static void main(String str[]) throws CloneNotSupportedException{
		

        EdgeImpl edge = new EdgeImpl();
        
        edge.setEdgeName("a");
        
        Edge edgeClone = (EdgeImpl) edge.clone();
        edgeClone.setEdgeName("b");
        
        
 //      
//        ClassNode nodeS = new ClassNodeImpl("source");
//        ClassNode nodeT = new ClassNodeImpl("target");
//        
//        ClassEdge edge1 = new ClassEdgeImpl(nodeS, nodeT, new Cardinality("*"),new Cardinality("*"));
//        ClassEdge edge1Clone = (ClassEdgeImpl) edge1.clone();
//        ClassNode nodeSClone = (ClassNodeImpl) nodeS.clone();
//		
        
        ActivityNode nodeS = new ActivityNodeImpl("source");
        ActivityNode nodeT = new ActivityNodeImpl("target");
        
//        ActivityEdge edge1 = new ActivityEdgeImpl(nodeS, nodeT, new Cardinality("*"),new Cardinality("*"));
        ActivityEdge edge1 = new ActivityEdgeImpl(nodeS, nodeT, null);
        ActivityEdge edge1Clone = (ActivityEdgeImpl) edge1.clone();
        ActivityNode nodeSClone = (ActivityNodeImpl) nodeS.clone();
        
		System.out.print("\n edge: " + edge.getEdgeName());
		System.out.print("\n edgeClone: " + edgeClone.getEdgeName());
		
	}
	
}
