package org.processmining.ocbc.models.visualization.cell;

import java.awt.geom.Point2D;

import org.jgraph.graph.GraphConstants;


public class ClassEdgeCell extends MEdgeCell {  
	/**
	 * 
	 */
	private static final long serialVersionUID = 855369768491857978L;
	/**
	 * 
	 */

	/**
	 * 
	 */

	private String whichEnd;
	private Object[] labels = new Object[2];
	
    public ClassEdgeCell() {  
      this(null);  
    }  
  // Construct Cell for Userobject  
    public ClassEdgeCell(Object userObject) {  
    	super(userObject);  
    }
    public ClassEdgeCell(String alwaysCardinality, String eventuallyCardinality) {  
    	this.labels[0] = "□" + alwaysCardinality;
    	this.labels[1] = "◇" + eventuallyCardinality;
     }     
    
    public void setCardinalityCharacters(String alwaysCardinality, String eventuallyCardinality) {
    	this.labels[0] = "□" + alwaysCardinality;
    	this.labels[1] = "◇" + eventuallyCardinality;

    }
    
    public String getWhichEnd() {
    	return whichEnd;
    }
    
    public void setWhichEnd(String whichEnd) {
    	this.whichEnd = whichEnd;
    }
    
	/**
	 * setDisplay
	 */
	public void displayCardinality() {
    	
		double x = GraphConstants.PERMILLE / 2;
		double y = 10;

		Point2D[] labelPositions = new Point2D[]{ new Point2D.Double(x, y), new Point2D.Double(x+20, y+20) };

		GraphConstants.setExtraLabelPositions(getAttributes(), labelPositions);
		GraphConstants.setExtraLabels(getAttributes(), labels);
		
	}
	
} 