package org.processmining.ocbc.models.visualization.view;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;

import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.CellView;
import org.processmining.ocbc.models.visualization.declare.DEdgeRenderer;
import org.processmining.ocbc.models.visualization.declare.DEdgeView;
import org.processmining.ocbc.models.visualization.declare.DGraphConstants;

//public class AOCEdgeRenderer extends DEdgeRenderer {
//
//	public static enum EventType {
//		TIMEOUT("TO"), MESSAGE("Mes");
//		private final String s;
//
//		EventType(String s) {
//			this.s = s;
//		}
//
//		public String toString() {
//			return s;
//		}
//	};
//
//	/**
//	 * 
//	 */
//	private static final long serialVersionUID = 4910262989128580150L;
//	protected EventType type;

//	public void paint(Graphics g) {   
//	       
//	       try {  
//	            if (gradientColor != null && !preview && isOpaque()) {  
//	                setOpaque(false);  
//	                Graphics2D g2d = (Graphics2D) g;  
//	                g2d.setPaint(new GradientPaint(0, 0, getBackground(),  
//	                        getWidth(), getHeight(), gradientColor, true));  
//	                 
//	                 Stroke dash = new BasicStroke(2.5f,BasicStroke.CAP_BUTT,BasicStroke.JOIN_ROUND,
//	    	                 3.5f,new float[]{15,10,},0f);
//	                 g2d.setStroke(dash);
//	                 g2d.setColor(Color.yellow);
//	    	                 
//	                 g2d.drawLine(0, 0, 100, 100);
////	                 g2d.fillRoundRect(0, 0, 70, 60, 20, 20);
//	                 
//
//	            }  
//	            super.paint(g);  
//	            paintSelectionBorder(g);  
//	        } catch (IllegalArgumentException e) {  
//	            // JDK Bug: Zero length string passed to TextLayout constructor  
//	        }  
//	}
	
	/*
	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
	 * of fifferent color.
	 */
//	@Override
//	public void paint(final Graphics g) {
//		final Graphics2D g2 = (Graphics2D) g;
//		super.paint(g);
//		System.out.print("enter paint AOCEdgeRenderer");
//		
//		if (view.lineShape != null) {
//		{
//			g2.setColor(Color.blue);
//			g2.draw(view.endShape);
//		}
//	}
//
//	}


//}






public class AOCEdgeRenderer extends DEdgeRenderer {

//	/**
//	 * 
//	 */
//	private static final long serialVersionUID = 1L;
//	public ClassEdgeRenderer() {
//		super();
//	}
//	/*
//	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
//	 * of fifferent color.
//	 */
//	public void paint(final Graphics g) {
//		final Graphics2D g2 = (Graphics2D) g;
//		EdgeView view = new EdgeView();
//
//		if (view.lineShape != null) {
//			g2.setColor(Color.red);
////			g2.draw(view.lineShape);
//			g2.drawLine(10, 100, 20, 60);;
//		}
//	}


	private static final long serialVersionUID = -2245131380109364539L;

	private float[] dash = {25,25};
	protected transient Color middleColor;
 
	
	/** Painting attributes of the current edgeview */
	protected transient int lineNumber;
	protected transient float width;

	/**
	 * Constructs a renderer that may be used to render edges.
	 */
	public AOCEdgeRenderer() {
		super();
	}

	/**
	 * Paint the current view's direction. Sets tmpPoint as a side-effect such
	 * that the invoking method can use it to determine the connection point to
	 * this decoration.
	 * 
	 * @param size
	 *            int
	 * @param style
	 *            int
	 * @param src
	 *            Point2D
	 * @param dst
	 *            Point2D
	 * @return Shape
	 */
//	@Override
//	protected Shape createLineEnd(final int size, final int style, final Point2D src, final Point2D dst) {
//		if ((src == null) || (dst == null)) {
//			return null;
//		}
//		if (style != DGraphConstants.ARROW_TECHNICAL_CIRCLE) {
//			return super.createLineEnd(size, style, src, dst);
//		} else {
//			final Area areaCircle = new Area(super.createLineEnd(size, GraphConstants.ARROW_CIRCLE, src, dst));
//			final Shape arrow = super.createLineEnd(size, GraphConstants.ARROW_TECHNICAL, src, dst);
//			final Area areaPoly = new Area(arrow);
//			areaCircle.add(areaPoly);
//			return areaCircle;
//		}
//	}
	


	/**
	 * Installs the attributes of specified cell in this renderer instance. This
	 * means, retrieve every published key from the cells hashtable and set
	 * global variables or superclass properties accordingly.
	 * 
	 * @param view
	 *            the cell view to retrieve the attribute values from.
	 */

	@Override
	protected void installAttributes(final CellView view) {
		super.installAttributes(view);
		final AttributeMap map = view.getAllAttributes();
		lineNumber = DGraphConstants.getLineNumber(map);

		width = lineWidth;
		lineWidth = switchWidth(lineNumber);

	}

	/**
	 * getDEdgeView
	 * 
	 * @return DEdgeView
	 */
	public DEdgeView getDEdgeView() {
		if (view instanceof DEdgeView) {
			return (DEdgeView) view;
		}
		return null;
	}

	/*
	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
	 * of fifferent color.
	 */
	@Override
	public void paint(final Graphics g) {
		final Graphics2D g2 = (Graphics2D) g;
		super.paint(g);
		System.out.println("set color");
		drawLines(g2);
	}

	/**
	 * @param g2
	 *            Graphics2D
	 */
	private void drawLines(final Graphics2D g2) {
		lineNumber = 2;
		
		if (lineNumber > 1) {
			Color color = getForeground();
			for (int i = lineNumber - 1; i > 0; i--) {
				final float w = switchWidth(i);
				color = switchColor(color);
				drawLine(g2, w, color);
			}
		}
	}

	private float switchWidth(final int number) {
		return width * ((2 * number) - 1);
	}

	private Color switchColor(final Color color) {
		Color c = getForeground();
		if (color != null) {
			if (color.equals(this.getBackground())) {
				c = this.getForeground();
			} else {
				c = this.getBackground();
			}
		}
		return c;
	}

	/**
	 * @param g2
	 *            Graphics2D
	 * @param width
	 *            int
	 * @param color
	 *            Color
	 */
	private void drawLine(final Graphics2D g2, final float width, final Color color) {
//		if (view.lineShape != null) {
////			g2.setColor(color);
//			g2.setColor(Color.white);
////			g2.setStroke(getStroke(width));
//			System.out.println("set stroke");
//			g2.draw(view.lineShape);
//		}
	}

	private Stroke getStroke(final float width) {
		Stroke s = null;
//		if (lineDash != null) { // Dash For Line Only
			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, dash, 1);
//		} else {
//			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
//		}

//		if (selected) { // Paint Selected
//			s = GraphConstants.SELECTION_STROKE;
//		}
		return s;
	}


}

