package org.processmining.ocbc.models.visualization.view;

//import java.awt.Color;
//import java.awt.Graphics;
//import java.awt.Graphics2D;
//
//import org.processmining.ocbcmodel.visualization.declare.DEdgeRenderer;
//
//public class ClassEdgeRenderer extends DEdgeRenderer {
//
//	/**
//	 * 
//	 */
//	private static final long serialVersionUID = 1L;
//	public ClassEdgeRenderer() {
//		super();
//	}
//	/*
//	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
//	 * of fifferent color.
//	 */
//	@Override
//	public void paint(final Graphics g) {
//		final Graphics2D g2 = (Graphics2D) g;
//		super.paint(g);
//		System.out.print("enter paint ClassEdgeRenderer");
//		if (view.lineShape != null) {
//			System.out.print("enter view.lineShape != null");
//			g2.setColor(Color.red);
//			g2.draw(view.lineShape);
//		}
//	}
//
//
//
//
//
//}



import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;

import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.CellView;
import org.jgraph.graph.GraphConstants;
import org.processmining.ocbc.models.visualization.declare.DEdgeRenderer;
import org.processmining.ocbc.models.visualization.declare.DEdgeView;
import org.processmining.ocbc.models.visualization.declare.DGraphConstants;



public class ClassEdgeRenderer extends DEdgeRenderer {

//	/**
//	 * 
//	 */
//	private static final long serialVersionUID = 1L;
//	public ClassEdgeRenderer() {
//		super();
//	}
//	/*
//	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
//	 * of fifferent color.
//	 */
//	public void paint(final Graphics g) {
//		final Graphics2D g2 = (Graphics2D) g;
//		EdgeView view = new EdgeView();
//
//		if (view.lineShape != null) {
//			g2.setColor(Color.red);
////			g2.draw(view.lineShape);
//			g2.drawLine(10, 100, 20, 60);;
//		}
//	}


	private static final long serialVersionUID = -2245131380109364539L;

	private int repaintNum = 0;
	protected transient Color middleColor;

	/** Painting attributes of the current edgeview */
	protected transient int lineNumber;
	protected transient float width;

	/**
	 * Constructs a renderer that may be used to render edges.
	 */
	public ClassEdgeRenderer() {
		super();
	}

	/**
	 * Paint the current view's direction. Sets tmpPoint as a side-effect such
	 * that the invoking method can use it to determine the connection point to
	 * this decoration.
	 * 
	 * @param size
	 *            int
	 * @param style
	 *            int
	 * @param src
	 *            Point2D
	 * @param dst
	 *            Point2D
	 * @return Shape
	 */
//	@Override
//	protected Shape createLineEnd(final int size, final int style, final Point2D src, final Point2D dst) {
//		if ((src == null) || (dst == null)) {
//			return null;
//		}
//		if (style != DGraphConstants.ARROW_TECHNICAL_CIRCLE) {
//			return super.createLineEnd(size, style, src, dst);
//		} else {
//			final Area areaCircle = new Area(super.createLineEnd(size, GraphConstants.ARROW_CIRCLE, src, dst));
//			final Shape arrow = super.createLineEnd(size, GraphConstants.ARROW_TECHNICAL, src, dst);
//			final Area areaPoly = new Area(arrow);
//			areaCircle.add(areaPoly);
//			return areaCircle;
//		}
//	}
	
	/**
	 * Paint double arrows.
	 * 
	 * @param size
	 *            int
	 * @param style
	 *            int
	 * @param src
	 *            Point2D
	 * @param dst
	 *            Point2D
	 * @return Shape
	 */
//	@Override
//	protected Polygon createLineEnd(int size, int style, Point2D src, Point2D dst) {
//		if (src == null || dst == null)
//			return null;
//		
//		int d = (int) Math.max(1, dst.distance(src));
//		int ax = (int) -(size*2* (dst.getX() - src.getX()) / d);
//		int ay = (int) -(size*2* (dst.getY() - src.getY()) / d);
//		
//		Polygon poly = new Polygon();
//		poly.addPoint((int) dst.getX(), (int) dst.getY());
//		poly.addPoint((int) (dst.getX() + ax/2 + ay / 4), (int) (dst.getY()
//				+ ay/2 - ax/4));
//		
//		poly.addPoint((int) (dst.getX() + ax/2 ), (int) (dst.getY()
//				+ ay/2));
//		
//		poly.addPoint((int) (dst.getX() + ax  + ay / 4), (int) (dst.getY()
//				+ ay - ax/4));
//					
//		poly.addPoint((int) (dst.getX() + ax - ay / 4), (int) (dst.getY()
//				+ ay + ax / 4));
//					
//		poly.addPoint((int) (dst.getX() + ax/2 ), (int) (dst.getY()
//				+ ay/2));
//					
//		Point2D last = (Point2D) dst.clone();
//			
//		poly.addPoint((int) (last.getX() + ax/2 - ay / 4), (int) (last.getY()
//				+ ay/2 + ax / 4));					
//		return poly;		  		
//	}

	/**
	 * Installs the attributes of specified cell in this renderer instance. This
	 * means, retrieve every published key from the cells hashtable and set
	 * global variables or superclass properties accordingly.
	 * 
	 * @param view
	 *            the cell view to retrieve the attribute values from.
	 */
	@Override
	protected void installAttributes(final CellView view) {
		super.installAttributes(view);
		final AttributeMap map = view.getAllAttributes();
		lineNumber = DGraphConstants.getLineNumber(map);

		width = lineWidth;
		lineWidth = switchWidth(lineNumber);

	}

	/**
	 * getDEdgeView
	 * 
	 * @return DEdgeView
	 */
	public DEdgeView getDEdgeView() {
		if (view instanceof DEdgeView) {
			return (DEdgeView) view;
		}
		return null;
	}

	/*
	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
	 * of fifferent color.
	 */
	@Override
	public void paint(final Graphics g) {
		final Graphics2D g2 = (Graphics2D) g;
		super.paint(g);
		System.out.println("set color");
		drawLines(g2);
	}

	/**
	 * @param g2
	 *            Graphics2D
	 */
	private void drawLines(final Graphics2D g2) {
		lineNumber = 2;
		if (lineNumber > 1) {
			Color color = getForeground();
			for (int i = lineNumber - 1; i > 0; i--) {
				final float w = switchWidth(i);
				color = switchColor(color);
				drawLine(g2, w, color);
			}
		}
	}

	private float switchWidth(final int number) {
		return width * ((2 * number) - 1);
	}

	private Color switchColor(final Color color) {
		Color c = getForeground();
		if (color != null) {
			if (color.equals(this.getBackground())) {
				c = this.getForeground();
			} else {
				c = this.getBackground();
			}
		}
		return c;
	}

	/**
	 * @param g2
	 *            Graphics2D
	 * @param width
	 *            int
	 * @param color
	 *            Color
	 */
	private void drawLine(final Graphics2D g2, final float width, final Color color) {
//		if (view.lineShape != null) {
////			g2.setColor(color);
//			g2.setColor(Color.black);
//			g2.setStroke(getStroke(width));
//			System.out.println("class edge renderer change color");
//			g2.draw(view.lineShape);
//		}
	}

	private Stroke getStroke(final float width) {
		Stroke s = null;
		if (lineDash != null) { // Dash For Line Only
			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, lineDash, dashOffset);
		} else {
			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
		}

		if (selected) { // Paint Selected
			s = GraphConstants.SELECTION_STROKE;
		}
		return s;
	}


}
